(function() {

	if (typeof jQuery === 'undefined') {
		return;
	}

	jQuery(document).ready(function() {

		jQuery('#jb-clipboard').on('click', function() {
			jQuery('#jb-clip').trigger('select');
			var success = '';
			if (window.navigator.clipboard !== undefined) {
				window.navigator.clipboard.writeText($('#jb-clip').val()).then(function() {
					success = 'has';
				}, function() {
					success = 'has not';
				});
			} else {
				try {
					success = document.execCommand('copy') ? 'has' : 'has not';
				} catch (error) {
					success = 'has not';
				}
			}
			window.alert('The Juicebox Gallery shortcode tag ' + success + ' been successfully copied to the clipboard.');
		});

		jQuery('.jb-form').on('submit', function() {
			jQuery('.jb-button').prop('disabled', true);
			jQuery(this).find(':input').not('.jb-button').prop('disabled', false);
		});

		jQuery('.jb-cancel').on('click', function() {
			jQuery('.jb-button').prop('disabled', true);
			window.location.href = jbManageGalleries;
		});

		jQuery('#jb-e-library').change(function() {
			switch (jQuery('#jb-e-library').val()) {
				case 'media':
					jQuery('#jb-toggle-source-media').show();
					jQuery('.jb-toggle-source').not('#jb-toggle-source-media').hide();
					break;
				case 'flickr':
					jQuery('#jb-toggle-source-flickr').show();
					jQuery('.jb-toggle-source').not('#jb-toggle-source-flickr').hide();
					break;
				case 'nextgen':
					jQuery('#jb-toggle-source-nextgen').show();
					jQuery('.jb-toggle-source').not('#jb-toggle-source-nextgen').hide();
					break;
				case 'picasa':
					jQuery('#jb-toggle-source-picasa').show();
					jQuery('.jb-toggle-source').not('#jb-toggle-source-picasa').hide();
					break;
				default:
					break;
			}
		});

		jQuery('#jb-e-library').triggerHandler('change');

		if (jQuery('#jb-set-defaults-container').length > 0) {
			jQuery('#jb-e-library').prop('disabled', true);
			jQuery('.jb-toggle-source').find(':input').prop('disabled', true);
		}

	});

})();
