var jbGetEditor = function() {
	var win = typeof window.parent !== 'undefined' ? window.parent : window;
	if (typeof win.CKEDITOR !== 'undefined') {
		return 'ckeditor';
	} else if (typeof win.CodeMirror !== 'undefined') {
		return 'codemirror';
	} else if (typeof win.FCKeditor !== 'undefined') {
		return 'fckeditor';
	} else if (typeof win.wp !== 'undefined' && typeof win.wp.blocks !== 'undefined') {
		return 'gutenberg';
	} else if (typeof win.quickPressLoad !== 'undefined') {
		return 'quickpress';
	} else if (typeof win.tinyMCE !== 'undefined' && (!win.tinyMCE.activeEditor || win.tinyMCE.activeEditor.isHidden())) {
		return 'text';
	} else if (typeof win.tinyMCE !== 'undefined' && win.tinyMCE.activeEditor && !win.tinyMCE.activeEditor.isHidden()) {
		return 'visual';
	} else {
		return 'unknown';
	}
};

var jbGetId = function() {
	return jQuery('.wp-media-buttons:eq(0) .add_media').attr('data-editor') || 'content';
};

var JB = typeof window.JB !== 'undefined' ? window.JB : {};

JB.Gallery = function() {

	return {

		embed: function() {

			if (typeof jQuery === 'undefined') {
				return;
			}

			var win = typeof window.parent !== 'undefined' ? window.parent : window;

			var editor = jbGetEditor();
			var id = jbGetId();

			if (editor === 'ckeditor' && (typeof win.CKEDITOR.instances.content === 'undefined' || win.CKEDITOR.instances.content.mode !== 'wysiwyg')) {
				win.alert('You must be in WYSIWYG edit mode to insert a Juicebox Gallery shortcode tag.');
				return;
			}
			if (editor === 'codemirror') {
				win.alert('The CodeMirror editor is not supported by WP-Juicebox. Please use the Juicebox Gallery shortcode tag provided.');
			}
			if (editor === 'fckeditor' && win.FCKeditorAPI.GetInstance(id).EditMode !== 0) {
				win.alert('You must be in WYSIWYG edit mode to insert a Juicebox Gallery shortcode tag.');
				return;
			}
			if (editor === 'unknown') {
				win.alert('WP-Juicebox is unable to determine the editor. Please use the Juicebox Gallery shortcode tag provided.');
			}

			var postContent = '';
			switch (editor) {
				case 'ckeditor':
					postContent = win.CKEDITOR.instances.content.getData();
					break;
				case 'fckeditor':
					postContent = win.FCKeditorAPI.GetInstance(id).GetData();
					break;
				case 'gutenberg':
					postContent = win.wp.data.select('core/editor').getEditedPostContent();
					break;
				case 'quickpress':
				case 'text':
					postContent = jQuery(win.edCanvas).val();
					break;
				case 'visual':
					postContent = win.tinyMCE.activeEditor.getContent();
					break;
				case 'codemirror':
				case 'unknown':
				default:
					break;
			}

			var str = typeof postContent !== 'undefined' ? postContent : '';

			var matches = str.match(/\[juicebox\s+gallery_id="[1-9][0-9]*".*?\]/gi);
			var gallery = matches !== null ? matches.length : 0;

			if (gallery > 0) {
				var term = gallery > 1 ? gallery + ' Juicebox Galleries' : 'a Juicebox Gallery';
				win.alert('This ' + jbPostType + ' already contains ' + term + '.');
				return;
			}

			if (typeof this.configUrl !== 'string' || typeof win.tb_show !== 'function') {
				win.alert('WP-Juicebox is unable to display the gallery settings.');
				return;
			}

			var connector = /\?/.test(this.configUrl) ? '&amp;' : '?';
			var url = this.configUrl + connector + 'TB_iframe=true&amp;width=600&amp;height=400';
			win.tb_show('Add Juicebox Gallery', url , false);
		}
	};
}();

JB.Gallery.Generator = function() {

	var insertTag = function(tag) {

		var win = typeof window.parent !== 'undefined' ? window.parent : window;

		var editor = jbGetEditor();
		var id = jbGetId();

		switch (editor) {
			case 'ckeditor':
				win.CKEDITOR.instances.content.insertText(tag);
				break;
			case 'fckeditor':
				win.FCKeditorAPI.GetInstance(id).InsertHtml(tag);
				break;
			case 'gutenberg':
				var block = win.wp.blocks.createBlock('core/shortcode', {
					text: tag
				});
				win.wp.data.dispatch('core/editor').insertBlock(block);
				break;
			case 'quickpress':
			case 'text':
				if (typeof win.QTags !== 'undefined' && typeof win.QTags.insertContent === 'function') {
					win.QTags.insertContent(tag);
				} else if (typeof win.edInsertContent === 'function') {
					win.edInsertContent(win.edCanvas, tag);
				} else {
					win.alert('WP-Juicebox is unable to insert a Juicebox Gallery shortcode tag.');
				}
				break;
			case 'visual':
				var version = parseInt(win.tinyMCE.majorVersion, 10);
				if (version >= 3) {
					win.tinyMCE.activeEditor.focus(false);
					win.tinyMCE.activeEditor.insertContent(tag);
				} else {
					win.tinyMCE.execCommand('mceFocus', false, 'tinymce');
					win.tinyMCE.activeEditor.execCommand('mceInsertContent', false, tag);
				}
				break;
			case 'codemirror':
			case 'unknown':
			default:
				win.alert('Please use this Juicebox Gallery shortcode tag: ' + tag);
				break;
		}

	};

	return {

		initialize: function() {

			if (typeof jQuery === 'undefined') {
				return;
			}

			jQuery('#jb-add-gallery').on('click', function() {
				jQuery('.jb-button').prop('disabled', true);
				jQuery('#jb-add-gallery-form').find(':input').not('.jb-button').prop('disabled', false);
				jQuery.post(JB.Gallery.Generator.postUrl, jQuery('#jb-add-gallery-form').serialize(), function(data) {
					var dataInteger = parseInt(data, 10);
					if (!isNaN(dataInteger)) {
						var tag = '[juicebox gallery_id="' + Math.abs(dataInteger) + '"]';
						insertTag(tag);
					} else {
						var win = typeof window.parent !== 'undefined' ? window.parent : window;
						win.alert('WP-Juicebox is unable to determine the gallery settings.');
					}
				}).fail(function() {
					var win = typeof window.parent !== 'undefined' ? window.parent : window;
					win.alert('WP-Juicebox is unable to insert a Juicebox Gallery shortcode tag.');
				}).always(function() {
					var win = typeof window.parent !== 'undefined' ? window.parent : window;
					win.tb_remove();
				});
			});

			jQuery('#jb-add-cancel').on('click', function() {
				jQuery('.jb-button').prop('disabled', true);
				var win = typeof window.parent !== 'undefined' ? window.parent : window;
				win.tb_remove();
			});
		}
	};
}();
